Subject: Re: linux-next: build warning after merge of the akpm tree

From: Steven Price <[email-masked]>
Date: Wed, 8 Jan 2020 14:52:49 +0000

On Tue, Jan 07, 2020 at 11:11:07PM +0000, Andrew Morton wrote:
> On Mon, 6 Jan 2020 17:07:44 +1100 Stephen Rothwell <[email-masked]> wrote:
> 
> > Hi all,
> > 
> > After merging the akpm tree, today's linux-next build (x86_64
> > allmodconfig) produced this warning:
> > 
> > arch/x86/mm/dump_pagetables.c: In function 'ptdump_walk_pgd_level_core':
> > arch/x86/mm/dump_pagetables.c:403:1: warning: the frame size of 2128 bytes is larger than 2048 bytes [-Wframe-larger-than=]
> >   403 | }
> >       | ^
> > 
> > Introduced by commit
> > 
> >   710fae4f03f2 ("x86: mm: convert dump_pagetables to use walk_page_range")
> > 
> 
> (gdb) p sizeof(struct mm_struct)
> $1 = 1664
> 
> yup, that'll do it.

Ok, looks like I'll have to do something a little bit more clever than
the "fake_mm" hack I used before. The trouble is x86 now has two PGDs
due to the PAGE_TABLE_ISOLATION feature. I was trying to isolate this
quirk to the x86 code, but it looks like we need some way of passing an
"override" down for the PGD.

I'll post a possible fix as a reply to this post.

Steve